Qt 5.6 | Qt Core | C++ Classes | QObject

Qt 5.6.2 Reference Documentation

# Obsolete Members for QObject

The following members of class QObject are obsolete. They are provided to keep old source code working. We strongly advise against using them in new code.

## Static Public Members

`(obsolete)` QString | trUtf8(const char *sourceText, const char *disambiguation = Q_NULLPTR, int n = -1)

## Related Non-Members

`(obsolete)` T | qFindChild(const QObject *obj, const QString &name = QString())
`(obsolete)` QList<T> | qFindChildren(const QObject *obj, const QString &name = QString())

## Macros

`(obsolete)` | Q_ENUMS(...)
`(obsolete)` | Q_FLAGS(...)

## Member Function Documentation

### `[static]` QString QObject::trUtf8(const char *sourceText, const char *disambiguation = Q_NULLPTR, int n = -1)

Returns a translated version of sourceText, or QString::fromUtf8(sourceText) if there is no appropriate version. It is otherwise identical to tr(sourceText, disambiguation, n).

Warning: This method is reentrant only if all translators are installed before calling this method. Installing or removing translators while performing translations is not supported. Doing so will probably result in crashes or other undesirable behavior.

Warning: For portability reasons, we recommend that you use escape sequences for specifying non-ASCII characters in string literals to trUtf8(). For example:

      label->setText(tr("F\374r \310lise"));

See also tr(), QCoreApplication::translate(), and Internationalization with Qt.

## Related Non-Members

### T qFindChild(const QObject *obj, const QString &name = QString())

This function overloads qFindChildren().

This function is equivalent to obj->findChild<T>(name).

Note: This function was provided as a workaround for MSVC 6 which did not support member template functions. It is advised to use the other form in new code.

See also QObject::findChild().

### QList<T> qFindChildren(const QObject *obj, const QString &name = QString())

This function overloads qFindChildren().

This function is equivalent to obj->findChildren<T>(name).

Note: This function was provided as a workaround for MSVC 6 which did not support member template functions. It is advised to use the other form in new code.

See also QObject::findChildren().

## Macro Documentation

### Q_ENUMS(...)

This macro registers one or several enum types to the meta-object system.

For example:

      class MyClass : public QObject
      {
          Q_OBJECT

      public:
          MyClass(QObject *parent = 0);
          ~MyClass();

          enum Priority { High, Low, VeryHigh, VeryLow };
          Q_ENUM(Priority)
          void setPriority(Priority priority);
          Priority priority() const;
      };

If you want to register an enum that is declared in another class, the enum must be fully qualified with the name of the class defining it. In addition, the class defining the enum has to inherit QObject as well as declare the enum using Q_ENUMS().

In new code, you should prefer the use of the Q_ENUM() macro, which makes the type available also to the meta type system. For instance, QMetaEnum::fromType() will not work with types declared with Q_ENUMS().

See also Qt's Property System.

### Q_FLAGS(...)

This macro registers one or several flags types with the meta-object system. It is typically used in a class definition to declare that values of a given enum can be used as flags and combined using the bitwise OR operator.

Note: This macro takes care of registering individual flag values with the meta-object system, so it is unnecessary to use Q_ENUMS() in addition to this macro.

In new code, you should prefer the use of the Q_FLAG() macro, which makes the type available also to the meta type system.

See also Qt's Property System.